#include <stdio.h>
#include <vector>
#include <queue>
#include <assert.h>

#define INFIN 2000000000

using namespace std;

typedef struct road{
    int v;
    int w;
    int t;
    int a;
    int l;
} road;

int t[50005];
road rtb [1000010];
vector <road*> nb[50005];
priority_queue< pair<int,int> > lpq;

int main()
{
    int d;
    scanf ("%d", &d);
    while (d--)
    {
	int n, m;
	scanf ("%d%d", &n, &m);
	while (!lpq.empty()) lpq.pop();
	for (int i=0; i<=n; i++)
	    nb[i].clear();
	for (int i=0; i<=n; i++)
	    t[i]=INFIN;

	for (int i=0; i<m; i++)
	{
	    int u;
	    road r;
	    scanf ("%d%d%d%d%d%d", &u, &(r.v), &(r.w), &(r.t), &(r.a), &(r.l));
	    rtb[i]=r;
	    nb[u].push_back(&rtb[i]);
	}
	lpq.push (pair<int,int>(0,1));
	
	while (!lpq.empty())
	{
	    pair<int,int> p=lpq.top(); lpq.pop();
	    int u=p.second;
	    int ut=-p.first;
//	    fprintf (stderr, "Popped path to %d distance %d\n", u, ut);
	    if (ut<t[u] && ut<t[n])
	    {
//		fprintf (stderr, "Processing %d\n", u);
		t[u]=ut;
		for (vector<road*>::iterator i=nb[u].begin(); i!=nb[u].end(); i++)
		{
		    road p=*(*i);
//		    fprintf (stderr, "Processing path %d --> %d\n", u, p.v);
		    int mint=ut;
		    if (p.t>0)
		    {
			int mom=(10*p.t + ut - p.a) %p.t;
			if (mom>=p.l)
			{
			    mint -=mom;
			    mint +=p.t;
			}
		    }
		    assert (mint>=ut);
		    int tarr=mint+p.w;
		    assert (tarr<=1000001000);
		    if (tarr < t[p.v])
		    {
			lpq.push(pair<int,int>(-tarr, p.v));
//			fprintf (stderr, "Pushing to %d distance %d\n", p.v, tarr);
		    }
		}
	    }
	}
	
	if (t[n]<INFIN)
	    printf("%d\n", t[n]);
	else printf ("NIE\n");
    }
    return 0;
}
